//****************************************************************************
//*                                                                          *
//*             Systemy hromadne obsluhy - priklad 1: Lyzari                 *
//*                                                                          *
//****************************************************************************

#define max(a, b) ((a) > (b) ? (a) : (b))
#define min(a, b) ((a) < (b) ? (a) : (b))

#include "simulation.h"
#include "random.h"
//----- deklarace
class TLyzar;
class TVlek;
void status (CProcess * p, bool kotva);

CHead *Fronta;			// fronta, kam se radi lyzari cekajici na vlek                              
TLyzar *Lyzar;			// objekt Lyzar - chce pouzit vlek
TVlek *Vlek;			// objekt Vlek - odvlece po 1 lyzari na kazde kotve

const int MAXDF = 10;		// max. delka fronty - kdo se nevejde do fronty, spadne do rokle
int mrtvoly = 0;		// pocet mrtvych lyzaru v rokli
int lyzari = 0;			// pocet lyzaru celkem

int maxvf = 0;			// max. vyuzita delka fronty
double clovekocas = 0.0;	// kumulativni soucet delka_fronty*delta_cas (pro prumer)
double predcas = 0.0;		// predchozi cas (pro prumer)

class TLyzar:public CProcess	// trida TLyzar - je to proces
{
  virtual void Run ();		// telo procesu
public:
};


class TVlek:public CProcess	// trida TVlek
{
  virtual void Run ();		// telo procesu
public:
};

//----- definice chovani
void
TLyzar::Run ()			// telo procesu TLyzar
{
  double t;
  int df = Fronta->Cardinal ();	// delka fronty
  lyzari++;
  // zavleceni dalsiho pozadavku
  //*******
  //(new TLyzar)->ActivateDelay(negexp(1.0/30.0));       // prumerne 30 cas. jednotek
  //(new TLyzar)->ActivateDelay(negexp(1.0/60.0));     
  //(new TLyzar)->ActivateDelay(negexp(1.0/70.0));     
  //(new TLyzar)->ActivateDelay(negexp(1.0/90.0));     
  //(new TLyzar)->ActivateDelay(negexp(1.0/100.0));     

  (new TLyzar)->ActivateDelay (negexp (1.0 / 75.0));	//exponencialni rozlozeni, stred.h.=75
  //(new TLyzar)->ActivateDelay(uniform(70,80));         //rovnomerne rozlozeni, st.h.=75
  //*******
  if (df < MAXDF)
    {
      Into (Fronta);		// zaradi se do fronty a ceka
      df++;
      status (this, false);
      Passivate ();		// ceka na dokonceni obsluhy
      status (this, false);

      //aktualizujeme statisticke udaje
      t = Time ();
      clovekocas += df * (t - predcas);	//pricteme dalsi interval
      predcas = t;
      maxvf = max (maxvf, df);

    }
  else
    {
      // do fronty se uz nevejdeme, padame do rokle.
      mrtvoly++;
      status (this, false);
    }
  // konci metoda Run - proces je ukoncen.
}


void
TVlek::Run ()			// telo procesu TVlek
{
  CProcess *P = NULL;
  for (;;)
    {				// vlek jede porad dokola
      status (this, true);
      if (!Fronta->Empty ())
	{			// neni-li koho vyzvednout, jdeme zas cekat
	  P = (CProcess *) Fronta->First ();
	  P->Out ();		// vyber obslouzeneho lyzare z fronty,   
	  P->ActivateAt (Time ());	// vzbudime ho, aby se uklidil
	}
      //*******
      Hold (70);		// doba obsluhy   
      //*******
    }
}

/*----------------------------------------------*/
void
status (CProcess * p, bool kotva)
{
  const int maxf = min (MAXDF, 50);
  int df = Fronta->Cardinal ();
  int i;
  if (p == NULL)
    {				///hlavicka tabulky
      printf ("  Cas <mrtvoly> |fronta %*c|kotva\n", maxf - 4, ' ');
    }
  else
    {
      printf (" %8.2f, <%2d> |%2d ", p->Time (), mrtvoly,
	      Fronta->Cardinal ());
      for (i = 0; i < maxf; i++)
	{
	  putchar (i >= maxf - df ? 'L' : ' ');	// pocet 'L' = pocet lyzaru ve fronte
	}
      printf ("|%c|\n", kotva ? 'K' : ' ');
    }
}

/*----------------------------------------------*/
void
CSimulation::Run ()		// hlavni proces
{
  printf ("--- Ukazka pouziti modulu SIMULATION --cas %6.2f\n", Time ());
  printf ("Max. delka fronty: %d\n", MAXDF);
  status (NULL, false);
  Vlek = new TVlek ();		// vytvoreni objektu Vlek
  Fronta = new CHead ();	// vytvoreni fronty Fronta
  (new TLyzar)->ActivateAt (Time () + 10);	// vytvoreni a naplanovani prvniho pozadavku
  Vlek->ActivateAt (Time ());	// spusteni vleku

  //*******
  Hold (600);			// celkova doba simulace
  //*******
  printf ("\nVyuziti fronty: maximum=%d, prumer=%.2lg\n", maxvf,
	  (clovekocas / Time ()));
  printf ("Lyzari: celkem=%d, mrtvol=%d, umrtnost=%.2lg\n", lyzari, mrtvoly,
	  ((double) mrtvoly) / lyzari);
  //printf("Delka fronty: %ld\n\n", Fronta -> Cardinal());
  printf ("Konec simulace---cas: %f\n\n", Time ());
}
